'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _actions = require('./actions');

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

/**
 * This reducer will update the state with the most recent location history
 * has transitioned to.
 */
var routerReducer = function routerReducer(state) {
  var _ref = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
      type = _ref.type,
      payload = _ref.payload;

  if (type === _actions.LOCATION_CHANGE) {
    return _extends({}, state, payload);
  }

  return state;
};

var connectRouter = function connectRouter(history) {
  var initialRouterState = {
    location: history.location,
    action: history.action
  };
  // Wrap a root reducer and return a new root reducer with router state
  return function (rootReducer) {
    return function (state, action) {
      var routerState = initialRouterState;

      // Extract router state
      if (state) {
        var _state = state,
            router = _state.router,
            rest = _objectWithoutProperties(_state, ['router']);

        routerState = router || routerState;
        state = rest;
      }
      var reducerResults = rootReducer(state, action);

      return _extends({}, reducerResults, {
        router: routerReducer(routerState, action)
      });
    };
  };
};

exports.default = connectRouter;